require "defines"

normal_attack_sent_event = script.generate_event_name()
landing_attack_sent_event = script.generate_event_name()
remote.add_interface("freeplay",
{
  set_attack_data = function(data)
    global.attack_data = data
  end,

  get_attack_data = function()
    return global.attack_data
  end,

  get_normal_attack_sent_event = function()
    return normal_attack_sent_event
  end,
})

init_attack_data = function()
  global.attack_data = {
    -- whether all attacks are enabled
    enabled = true,
    -- this script is allowed to change the attack values attack_count and until_next_attack
    change_values = true,
    -- what distracts the creepers during the attack
    distraction = defines.distraction.byenemy,
    -- number of units in the next attack
    attack_count = 5,
    -- time to the next attack
    until_next_attack = 60 * 60 * 60,
  }
end

d = 32*3
bd = d*3
orange_color = {b = 0, r= 0.8, g = 0.4, a = 0.8}
purple_color = {b = 0.8, r= 0.4, g = 0, a = 0.8}

function make_forces()

  local s = game.surfaces["nauvis"]
  game.forces["player"].chart(s,{{ global.purple_team_x - bd,  global.purple_team_y -bd}, { global.purple_team_x + bd,  global.purple_team_y + bd}} )
  game.forces["player"].chart(s,{{ global.orange_team_x - bd,  global.orange_team_y -bd}, { global.orange_team_x + bd,  global.orange_team_y + bd}} )
  game.create_force("Purple")
  game.create_force("Orange")
  
end

function set_spawns()
  s = game.surfaces["nauvis"]
  game.daytime = 0.9
  ppnc = s.find_non_colliding_position("player",  global.purple_team_position, 64,4)
  opnc = s.find_non_colliding_position("player",  global.orange_team_position, 64,4)

--game.player.print(ppnc.x.." "..ppnc.y)
  if ppnc ~= nil and opnc ~= nil then
      game.forces["Purple"].set_spawn_position({ppnc.x,ppnc.y}, s)
      game.forces["Orange"].set_spawn_position({opnc.x,opnc.y}, s)
      for k, p in pairs (game.players) do
        p.print("Teams are now unlocked")
      end
      for k, entity in pairs(s.find_entities_filtered({area={{ppnc.x - bd, ppnc.y -bd}, {ppnc.x + bd, ppnc.y + bd}}, force= "enemy"})) do
        entity.destroy()
      end
      for k, entity in pairs(s.find_entities_filtered({area={{opnc.x - bd, opnc.y -bd}, {opnc.x + bd, opnc.y + bd}}, force= "enemy"})) do
        entity.destroy()
      end
    else for k, p in pairs (game.players) do 
      p.print("Map unsutitable, please restart")
    end
  end
end

function make_lobby()
  game.create_surface("Lobby", {width = 96, height = 32, starting_area = "big", water = "none"}) 
end

function set_starting_areas()
  local s = game.surfaces.nauvis
  s.set_tiles{
    {name = "water", position ={ global.purple_team_x + 16,  global.purple_team_y +16}},
    {name = "water", position ={ global.purple_team_x + 17,  global.purple_team_y +16}},
    {name = "water", position ={ global.purple_team_x + 16,  global.purple_team_y +17}},
    {name = "water", position ={ global.purple_team_x + 17,  global.purple_team_y +17}}}
        
  s.set_tiles{
    {name = "water", position = { global.orange_team_x + 16, global.orange_team_y +16}},
    {name = "water", position = { global.orange_team_x + 17, global.orange_team_y +16}},
    {name = "water", position = { global.orange_team_x + 16, global.orange_team_y +17}},
    {name = "water", position = { global.orange_team_x + 17, global.orange_team_y +17}}}

  for k, pr in pairs (s.find_entities_filtered{area = {{ global.purple_team_x-128,  global.purple_team_y-128},{ global.purple_team_x+128,  global.purple_team_y+128}}, type= "resource"}) do
    pr.destroy()
  end
  
  for k, orr in pairs (s.find_entities_filtered{area = {{ global.orange_team_x-128, global.orange_team_y-128}, { global.orange_team_x+128, global.orange_team_y+128}}, type= "resource"}) do
    orr.destroy()
  end
  
  for k, r in pairs (s.find_entities_filtered{area = {{-128, -128}, {128, 128}}, type= "resource"}) do
  
    local prx = r.position.x
    local pry = r.position.y
    local prx = prx +  global.purple_team_x
    local pry = pry +  global.purple_team_y
    local tile = s.get_tile(prx,pry).name
    
    if tile ~= "water" and tile ~= "deepwater" then
      s.create_entity{name = r.name, position = {prx,pry},force = r.force, amount = r.amount}
    end
      
    local nrx = r.position.x
    local nry = r.position.y
    local nrx = nrx +  global.orange_team_x
    local nry = nry +  global.orange_team_y
    local tile = s.get_tile(nrx,nry).name
      
    if tile ~= "water" and tile ~= "deepwater" then 
      s.create_entity{name = r.name, position = {nrx,nry}, force = r.force, amount = r.amount}
    end
    --r.destroy()
  end

end
function make_team_option(player)
  if player.gui.left.choose_team == nil then
    local frame = player.gui.left.add{name = "choose_team", type = "frame", direction = "vertical", caption="Choose your Team"}
          frame.add{type = "button", caption = "Join Orange Team", name = "orange"}.style.font_color = orange_color
          frame.add{type = "button", caption = "Join Purple Team", name = "purple"}.style.font_color = {r = 0.5,b = 1, g = 0.1}
          frame.add{type = "button", caption = "Check team numbers", name = "check"}.style.font_color = {r = 0.9,b = 0.9, g = 0.9}
		
	end
end

script.on_event(defines.events.on_player_created, function(event)

  local player = game.get_player(event.player_index)
  player.teleport({0,8},game.surfaces["Lobby"])
  player.print("You are currently in the Lobby area, please wait for teams to be unlocked")
 
	if game.tick > 90*60 then
    make_team_option(player)
  end
end)

script.on_init(function()

  global.purple_team_x = math.random(320,960)
  global.purple_team_y = math.random(320,960)
  global.purple_team_position ={ global.purple_team_x, global.purple_team_y}
  global.purple_team_area = {{ global.purple_team_x - d,  global.purple_team_y - d},{ global.purple_team_x + d,  global.purple_team_y + d}}
  global.orange_team_x = 0 - math.random(320,960)
  global.orange_team_y = 0 - math.random(320,960)
  global.orange_team_position = { global.orange_team_x, global.orange_team_y}
  global.orange_team_area = {{ global.orange_team_x - d,  global.orange_team_y - d},{ global.orange_team_x + d,  global.orange_team_y + d}}
  
  init_attack_data()
  make_forces()  
  make_lobby()

  
end)

script.on_event(defines.events.on_tick, function(event)
  if game.tick == 30*60 then
    for k, p in pairs (game.players) do
			p.print("Teams will unlock in 60 seconds")
		end
  end

  if game.tick == 60*60 then
    for k, p in pairs (game.players) do
      p.print("Teams will unlock in 30 seconds")
    end
  end
  if game.tick == 90 * 60 then
    set_spawns()
    for k, p in pairs (game.players) do
      make_team_option(p)
    end
    set_starting_areas()
    script.on_event(defines.events.on_tick, nil)
  end
end)

script.on_event(defines.events.on_gui_click, function(event)
 local s = game.surfaces.nauvis
 local player = game.players[event.player_index]
 
  if player.gui.left.choose_team ~= nil then
    if (event.element.name == "orange") then
      player.teleport(game.forces["Orange"].get_spawn_position(s), game.surfaces.nauvis)
      player.color = orange_color
      player.force = game.forces["Orange"]
      player.gui.left.choose_team.destroy()
      player.insert{name="iron-plate", count=8}
      player.insert{name="pistol", count=1}
      player.insert{name="basic-bullet-magazine", count=10}
      player.insert{name="burner-mining-drill", count = 1}
      player.insert{name="stone-furnace", count = 1}      
      for k, p in pairs (game.players) do
        p.print(player.name.." has joined team Orange")
      end
    end
	end
  if player.gui.left.choose_team ~= nil then
    if (event.element.name == "purple") then
      player.teleport(game.forces["Purple"].get_spawn_position(s), game.surfaces.nauvis)
      player.color = purple_color
      player.force = game.forces["Purple"]
      player.gui.left.choose_team.destroy()
      player.insert{name="iron-plate", count=8}
      player.insert{name="pistol", count=1}
      player.insert{name="basic-bullet-magazine", count=10}
      player.insert{name="burner-mining-drill", count = 1}
      player.insert{name="stone-furnace", count = 1}        
      for k, p in pairs (game.players) do
        p.print(player.name.." has joined team Purple")
      end
    end
  end
  if player.gui.left.choose_team ~= nil then
    if (event.element.name == "check") then
      local orange_count = 0
      local purple_count = 0
      for k, p in pairs (game.players) do
        if p.force == game.forces.Purple then purple_count = purple_count + 1 end
        if p.force == game.forces.Orange then orange_count = orange_count + 1 end
      end
      player.print("There are "..purple_count.." Players on Purple team and "..orange_count.." Players on Orange team")
    end
  end
end)
	-- for backwards compatibility
script.on_configuration_changed(function(data)
  if global.attack_data == nil then
    init_attack_data()
    if global.attack_count ~= nil then global.attack_data.attack_count = global.attack_count end
    if global.until_next_attacknormal ~= nil then global.attack_data.until_next_attack = global.until_next_attacknormal end
  end
  if global.attack_data.distraction == nil then global.attack_data.distraction = defines.distraction.byenemy end
  
end)

script.on_event(defines.events.on_rocket_launched, function(event)
  local force = event.rocket.force
  if event.rocket.get_item_count("satellite") > 0 then
    if global.satellite_sent == nil then
      global.satellite_sent = {}
    end
    if global.satellite_sent[force.name] == nil then
      game.set_game_state{game_finished=true, player_won=true, can_continue=true}
      global.satellite_sent[force.name] = 1
    else
      global.satellite_sent[force.name] = global.satellite_sent[force.name] + 1
    end
    for index, player in pairs(force.players) do
      if player.gui.left.rocket_score == nil then
        local frame = player.gui.left.add{name = "rocket_score", type = "frame", direction = "horizontal", caption={"score"}}
        frame.add{name="rocket_count_label", type = "label", caption={"", {"rockets-sent"}, ""}}
        frame.add{name="rocket_count", type = "label", caption="1"}
      else
        player.gui.left.rocket_score.rocket_count.caption = tostring(global.satellite_sent[force.name])
      end
    end
  else
    if (#game.players <= 1) then
      game.show_message_dialog{text = {"gui-rocket-silo.rocket-launched-without-satellite"}}
    else
      for index, player in pairs(force.players) do
        player.print({"gui-rocket-silo.rocket-launched-without-satellite"})
      end
    end
  end
end)
